SystemOrganization addCategory: #'Keymapping-Tests-Mocks'!
SystemOrganization addCategory: #'Keymapping-Tests'!

Morph subclass: #KMMockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests-Mocks'!

KMMockMorph subclass: #KMMockMorphSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests-Mocks'!

TestCase subclass: #AbstractKeymappingTest
	instanceVariableNames: 'default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:51'!
eventKey: character 
	^ self eventKey: character
		alt: false
		ctrl: false
		command: false
		shift: false! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:51'!
eventKey: character alt: aBoolean
	^ self eventKey: character
		alt: aBoolean
		ctrl: false
		command: false
		shift: false! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:51'!
eventKey: character alt: useAlt ctrl: useCtrl command: useCommand shift: useShift
	| event modifier code |
	event := KeyboardEvent new.
	modifier := 0.
	
	useShift 
		ifTrue: [ modifier := modifier + 8].
	useCtrl 
		ifTrue: [ modifier := modifier + 16].
	useAlt 
		ifTrue: [ modifier := modifier + 32].
	useCommand
		ifTrue: [ modifier := modifier + 64].
	
	code := character asInteger.
	event 
		setType: #keystroke
		buttons: modifier
		position:  0@0
		keyValue: code
		charCode: code
		hand: nil 
		stamp: Time now.
	^ event 	! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:52'!
eventKey: character command: aBoolean
	^ self eventKey: character
		alt: false
		ctrl: false
		command: aBoolean
		shift: false! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:51'!
eventKey: character ctrl: aBoolean
	^ self eventKey: character
		alt: false
		ctrl: aBoolean
		command: false
		shift: false! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:52'!
eventKey: character shift: aBoolean
	^ self eventKey: character
		alt: false
		ctrl: false
		command: false
		shift: aBoolean! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 2/19/2011 18:44'!
setUp
	default := KMRepository default.
	KMRepository default: KMRepository new! !

!AbstractKeymappingTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 2/19/2011 18:44'!
tearDown
	KMRepository default: default! !

AbstractKeymappingTest subclass: #KMCategoryTest
	instanceVariableNames: 'categoryContainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KMCategoryTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/18/2011 23:11'!
categoryContainer
	^ KMFactory keymapContainer! !

!KMCategoryTest methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 12/13/2011 17:17'!
testAddKeymapToCategory
	| categoryToAdd entry |
	categoryToAdd := KMCategory named: #TestCategory.
	entry := KMKeymap named: #Foo shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: [ "nothing" ].

	self assert: (categoryToAdd allEntries) size = 0.
	categoryToAdd addKeymapEntry: entry.
	self assert: (categoryToAdd allEntries) size = 1.! !

!KMCategoryTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 3/13/2011 17:33'!
testCreateExistentCategoryFails
	| categoryToAdd |
	categoryToAdd := #TestCategory.
	
	self assert: self categoryContainer categories size = 0.
	self categoryContainer addCategory: categoryToAdd.
	self assert: self categoryContainer categories size = 1.
	self should: [self categoryContainer addCategory: categoryToAdd] raise: Error.! !

!KMCategoryTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 3/13/2011 17:33'!
testCreateUnexistentCategory
	| categoryToAdd |
	categoryToAdd := KMCategory named: #TestCategory.
	
	self assert: self categoryContainer categories size = 0.
	self categoryContainer addCategory: categoryToAdd.
	self assert: self categoryContainer categories size = 1.
	self assert: (self categoryContainer includesCategory: categoryToAdd).! !

AbstractKeymappingTest subclass: #KMCombinationTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:07'!
testCombinationOfSimpleShortcuts
	| shortcut otherShortcut combination |
	shortcut := $a command.
	otherShortcut := $b ctrl.
	
	combination := shortcut | otherShortcut.
	
	self assert: (combination includes: shortcut).
	self assert: (combination includes: otherShortcut).
	
	self assert: ((combination collect: #platform) allSatisfy: [ :p | p = #all ]).! !

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:34'!
testCombinationSeveralShortcuts
	| shortcut platforms |
	platforms := Set new.
	
	shortcut := $a command mac | $a ctrl win | $a ctrl unix | $a alt.
	shortcut combinationsDo: [ :c | platforms add: c platform ].
	self assert: (platforms includes: #MacOSX).
	self assert: (platforms includes: #Windows).
	self assert: (platforms includes: #Unix).
	self assert: (platforms includes: #all).! !

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:22'!
testMacDependentShortcut
	| shortcut |
	shortcut := $a ctrl mac.
	
	self assert: (shortcut shortcut = $a ctrl).
	
	self assert: shortcut platform equals: #MacOSX.! !

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:11'!
testPlatformDependentShortcut
	| shortcut |
	shortcut := $a ctrl win.
	
	self assert: (shortcut shortcut = $a ctrl).
	
	self assert: shortcut platform equals: #Windows.! !

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:06'!
testShortcutIsSimpleCombination
	| shortcut |
	shortcut := $a command.
	self assert: (shortcut includes: shortcut).
	self assert: shortcut shortcut equals: shortcut.! !

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:17'!
testUnixDependentShortcut
	| shortcut |
	shortcut := $a ctrl unix.
	
	self assert: (shortcut shortcut = $a ctrl).
	
	self assert: shortcut platform equals: #Unix.! !

!KMCombinationTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 9/24/2012 11:16'!
testWindowsDependentShortcut
	| shortcut |
	shortcut := $a ctrl win.
	
	self assert: (shortcut shortcut = $a ctrl).
	
	self assert: shortcut platform equals: #Windows.! !

AbstractKeymappingTest subclass: #KMDispatcherTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KMDispatcherTestCase class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapEventBuilderClass
	^ KMFactory keymapEventBuilder! !

!KMDispatcherTestCase methodsFor: 'tests' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapContainer
	^ KMRepository default! !

!KMDispatcherTestCase methodsFor: 'tests' stamp: 'SeanDeNigris 7/11/2012 09:54'!
testAttach
	| morph category |
	category := KMCategory named: #TestBlah.	
	morph := BorderedMorph new.
	morph kmDispatcher targets isEmpty ifFalse: [ self error: 'should be empty' ].
	KMRepository default addCategory: category.
	morph attachKeymapCategory: #TestBlah.
	morph attachKeymapCategory: #TestBlah.
	self assert: morph kmDispatcher targets size equals: 1.! !

!KMDispatcherTestCase methodsFor: 'tests' stamp: 'GuillermoPolito 7/18/2012 11:21'!
testBuffering
	| morph flag category event1 event2 event3|
	category := KMCategory named: #TestBlah.
	
	morph := BorderedMorph new.
	KMRepository default attach: category to: BorderedMorph.
	
	flag := false.

	category addKeymapEntry: (KMKeymap named: #Foo shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: [flag := true]).
	category addKeymapEntry: (KMKeymap named: #Bar shortcut: $p asShortcut, $p asShortcut
		action: []).

	event1 := self eventKey: $a.
	morph kmDispatcher
		dispatchKeystroke: event1.
	self assert: morph kmDispatcher buffer size = 1.
	self assert: morph kmDispatcher buffer first = event1.
	
	event2 := self eventKey: $b.
	morph kmDispatcher
		dispatchKeystroke: event2.
	self assert: morph kmDispatcher buffer size = 2.
	self assert: morph kmDispatcher buffer first = event1.
	self assert: morph kmDispatcher buffer second = event2.
	
	event3 := self eventKey: $c.
	morph kmDispatcher
		dispatchKeystroke: event3.
	self assert: morph kmDispatcher buffer isEmpty.
	
	self assert: flag.! !

!KMDispatcherTestCase methodsFor: 'tests' stamp: 'SeanDeNigris 7/11/2012 10:12'!
testDetach

	| category1 category2 morph attachedCategories |
	category1 := KMCategory named: #TestBlah.
	category2 := KMCategory named: #TestAnother.
	morph := BorderedMorph new.
	KMRepository default addCategory: category1.
	KMRepository default addCategory: category2.
	morph attachKeymapCategory: #TestBlah.
	morph attachKeymapCategory: #TestAnother.
	morph kmDispatcher targets size = 2 ifFalse: [ self error: 'should have one category attached' ].

	morph detachKeymapCategory: #TestBlah.	
	attachedCategories := morph kmDispatcher targets collect: [ :e | e category name ].
	self assert: attachedCategories asArray equals: { #TestAnother }.

	self should: [ morph detachKeymapCategory: #NonExistent ] raise: Error.! !

!KMDispatcherTestCase methodsFor: 'tests' stamp: 'CamilloBruni 3/19/2011 19:50'!
testNoMultiTrigger
	| bm1 bm2 km flag1 flag2 category otherCategory |
	category := KMCategory named: #TestBlah.
	otherCategory := KMCategory named: #TestFoo.
	KMRepository default addCategory: category.
	KMRepository default addCategory: otherCategory.
	
	KMRepository default attach: category to: BorderedMorph.
	
	bm1 := BorderedMorph new.
	flag1 := false.

	category addKeymapEntry: (KMKeymap named: #Foo shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: [flag1 := true]).
	bm2 := KMMockMorph new.
	
	KMRepository default attach: otherCategory to: KMMockMorph.
	
	flag2 := false.

	otherCategory addKeymapEntry: (KMKeymap named: #Bar shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: [flag2 := true]).
	bm1 addMorphBack: bm2.
	
	{self eventKey: $a. self eventKey: $b. self eventKey: $c}
		do: [:e | bm2 dispatchKeystrokeForEvent: e].
	self deny: flag1.
	self assert: flag2.! !

!KMDispatcherTestCase methodsFor: 'tests' stamp: 'GuillermoPolito 10/20/2011 17:37'!
testNoStaggeredTrigger
	"Once a key sequence is recognized by a keymapper, all other  
	keymappers should clear their buffers"
	| bm1 bm2 km flag1 flag2 category otherCategory bufferBefore |
	
	category := KMCategory named: #TestBlah.
	otherCategory := KMCategory named: #TestFoo.
	
	KMRepository default addCategory: category.
	KMRepository default addCategory: otherCategory.
	
	bm1 := BorderedMorph new.
	KMRepository default attach: category to: EllipseMorph.
	
	flag1 := false.
	category addKeymapEntry: ( KMKeymap named: #Foo shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: [flag1 := true]).

	bm2 := RectangleMorph new.
	KMRepository default attach: otherCategory to: RectangleMorph.
	flag2 := false.

	otherCategory addKeymapEntry: (KMKeymap named: #Bar shortcut: $a asShortcut, $b asShortcut action:  [flag2 := true]).
	bm1 addMorphBack: bm2.
	bufferBefore := bm2 kmDispatcher buffer copy.
	{self eventKey: $a. self eventKey: $b. self eventKey: $c}
		do: [:e | bm2 dispatchKeystrokeForEvent: e].
	flag1 ifTrue: [ bufferBefore inspect ].
	self deny: flag1.
	self assert: flag2.! !

AbstractKeymappingTest subclass: #KMKeymapTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KMKeymapTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapEventBuilderClass
	^ KMFactory keymapEventBuilder! !

!KMKeymapTest methodsFor: 'tests' stamp: 'DeboraFortini 12/13/2011 17:32'!
assertExecutionOnClass: aClassToExecuteOn attachingTo: aClassToAttach
	| bm km flag category |
	category := (KMCategory named: #TestFoo).
	
	KMRepository default addCategory: category.
	KMRepository default attach: category to: aClassToAttach.
	
	bm := aClassToExecuteOn new.
	
	flag := false.
	category addKeymapEntry: (KMKeymap named: #Foo shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: [flag := true]).
	category addKeymapEntry: (KMKeymap named: #Bar shortcut: $p asShortcut, $p asShortcut action: []).
	
	{self eventKey: $a. self eventKey: $b. self eventKey: $c}
		do: [:e | bm dispatchKeystrokeForEvent: e].
		
	self assert: flag.! !

!KMKeymapTest methodsFor: 'tests' stamp: 'DeboraFortini 12/13/2011 17:23'!
keymapContainer
	^ KMRepository default! !

!KMKeymapTest methodsFor: 'tests' stamp: 'DeboraFortini 12/13/2011 17:33'!
testExecute
	self assertExecutionOnClass: KMMockMorph attachingTo: KMMockMorph! !

!KMKeymapTest methodsFor: 'tests' stamp: 'DeboraFortini 12/13/2011 17:33'!
testExecuteForSubclass
	self assertExecutionOnClass: KMMockMorphSubclass attachingTo: KMMockMorph! !

!KMKeymapTest methodsFor: 'tests' stamp: 'CamilloBruni 3/20/2011 23:31'!
testMatching
	| category blockAction a b c p|
	
	a := self eventKey: $a.
	b := self eventKey: $b.
	c := self eventKey: $c.
	p := self eventKey: $p.
	
	blockAction := [self error: 'error'].
	
	category := KMCategory named: #testCategory.
	category addKeymapEntry:  (KMKeymap named: #Foo shortcut: $a asShortcut, $b asShortcut, $c asShortcut action: blockAction).
	category addKeymapEntry:  (KMKeymap named: #Fum shortcut: $p asShortcut, $p asShortcut action: blockAction).

	self assert: (category matches: {a}).
	self deny: (category matches: {b}).
	self assert: (category matches: {a. b}).
	self assert: (category matchesCompletely: {a. b. c}).
	self assert: (category matches: {p}).
	self assert: (category matchesCompletely: {p. p.}).
	self deny: (category matches: {a. p. p}).
	self deny: (category matches: {self eventKey: $l. self eventKey: $m. self eventKey: $n. self eventKey: $o}).! !

AbstractKeymappingTest subclass: #KMPerInstanceTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KMPerInstanceTests methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/21/2012 21:37'!
testAddMoreThanOneHandler
	| flag morph |
	flag := 0.
	morph := KMMockMorph new.
	morph on: $i do: [ flag := flag + 1 ].
	morph on: $j do: [ flag := flag + 6 ].
	{ self eventKey: $i. self eventKey: $j }
		do: [:e | morph dispatchKeystrokeForEvent: e].
	self assert: flag equals: 7.! !

AbstractKeymappingTest subclass: #KMShortcutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:54'!
testAsString
	self assert: $a ctrl asString = 'Ctrl + A'.
	self assert: $b command asString = 'Cmd + B'.
	self assert: $c shift asString = 'Shift + C'.
	self assert: $d alt asString = 'Alt + D'.
	self assert: $e ctrl command asString = 'Ctrl + Cmd + E'.! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testBadComposedCmdShortcutFails
	^ self should: [ KMModifier ctrl ctrl ] raise: Error! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testChainIntegerSucceds
	^ self assert: ($e ctrl , 1) = ($e ctrl , 1)! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testChainShortcutSucceds
	^ self assert: ($e ctrl , $e ctrl) = ($e ctrl , $e ctrl)! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testChainSimpleCharsSucceds
	^ self assert: ($e ctrl , $e) = ($e ctrl , $e)! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testCmdIntegerSucceds
	^ self assert: 1 ctrl = 1 ctrl! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testCmdKeySucceds
	^ self assert: $e ctrl = $e ctrl! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/21/2012 20:39'!
testCmdShiftSucceds
	^ self assert: ($1 shift ctrl matches: {self eventKey: $1 alt: false ctrl: true command: false shift: true})! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testComplexChainMatches
	|eCtrl eShift e f|
	
	f := self eventKey: $f.
	eCtrl := self eventKey: $e ctrl: true.
	eShift := self eventKey: $e shift: true.
		
	self assert: (($e ctrl, $e shift, $f) matches: {eCtrl}).
	self assert: (($e ctrl, $e shift, $f) matches: {eCtrl. eShift}).
	self assert: (($e ctrl, $e shift, $f) matches: {eCtrl. eShift. f}).

	self deny: (($e ctrl, $e shift, $f) matchesCompletely: {eCtrl}).
	self deny: (($e ctrl, $e shift, $f) matchesCompletely: {eCtrl. eShift}).
	self assert: (($e ctrl, $e shift, $f) matchesCompletely: {eCtrl. eShift. f}).! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/31/2011 19:52'!
testCreation
	self assert: ($e asShortcut isKindOf: KMSingleKeyShortcut).
	self assert: ($e ctrl isKindOf: KMModifiedShortcut).
	self assert: ($e ctrl alt shift command isKindOf: KMModifiedShortcut).! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 1/21/2012 20:39'!
testModifiedShortcutsMatch
	|a oneShift oneCommand oneCommandShift|
	
	a := self eventKey: $a ctrl: true.
	oneShift := self eventKey: $1 shift: true.
	oneCommand := self eventKey: $1 command: true.
	oneCommandShift := self eventKey: $1 alt: false ctrl: false command: true shift: true.
	
	self assert: ($a ctrl matches: {a}).
	self assert: ($1 shift matches: {oneShift}).
	self assert: ($1 command matches: {oneCommand}).
	self assert: ($1 command shift matches: {oneCommandShift}).
	
	self deny: ($a ctrl matches: {self eventKey: $a command: true}).
	
	self deny: ($i command shift matches: {self eventKey: $i command: true}).
	self assert: ($i ctrl shift matches: {self eventKey: $i alt: false ctrl: true command: false shift: true}).
	self deny: ($i ctrl matches: {self eventKey: $i alt: false ctrl: true command: false shift: true}).
	
	self assert: ($a ctrl matchesCompletely: {a}).
	self assert: ($1 shift matchesCompletely: {oneShift}).
	self assert: ($1 command matchesCompletely: {oneCommand}).
	self assert: ($1 command shift matchesCompletely: {oneCommandShift}).! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testShiftKeySucceds
	^ self assert: $e shift = $e shift! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testSimpleChainMatches
	|e eCtrl |
	e := self eventKey: $e.
	eCtrl := self eventKey: $e ctrl: true.
	
	self assert: (($e ctrl, $e) matches: {eCtrl}).
	self assert: ($e ctrl matches: {eCtrl. e}).
	
	self deny: (($e ctrl, $e) matches: {eCtrl. self eventKey: $a}).
	self deny: ($e ctrl matches: {e}).! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 4/10/2011 02:27'!
testSingleShortcutsMatch
	|a one home |
	a := self eventKey: $a.
	one := self eventKey: 1 asCharacter.
	home := self eventKey: Character home.
	
	self assert: ($a asShortcut matches: {a}).
	self assert: (1 asShortcut matches: {one}).
	self assert: (Character home asShortcut matches: {home}).
	
	self deny: ($b asShortcut matches: {a}).
	
	self assert: ($a asShortcut matchesCompletely: {a}).
	self assert: (1 asShortcut matchesCompletely: {one}).! !

!KMShortcutTest methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/21/2011 21:56'!
testTripleChainShortcutSucceds
	^ self assert: ($e ctrl , $e ctrl , $d ctrl) = ($e ctrl , $e ctrl , $d ctrl)! !

AbstractKeymappingTest subclass: #KeymapBuilderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tests'!

!KeymapBuilderTest class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 3/18/2011 23:11'!
keymapEventBuilderClass
	^ KMFactory keymapEventBuilder! !

!KeymapBuilderTest methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 12/13/2011 17:36'!
testAddKeymapCreatesCategory
	self assert: KMRepository default categories isEmpty.
	
	KMRepository default
		initializeKeymap: #test
		executingOn: $r ctrl, $r asShortcut, $r asShortcut
		doing: [ :receiver | "nothing" ]
		inCategory: #Testing
		platform: #all.
	
	self assert: (KMRepository default includesCategoryNamed: #Testing).
	self assert: KMRepository default categories size = 1.! !

!KeymapBuilderTest methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 12/13/2011 17:38'!
testAddKeymapCreatesShortcut
	KMRepository default
		initializeKeymap: #test
		executingOn: $r ctrl, $r asShortcut, $r asShortcut
		doing: [ :receiver | "nothing" ]
		inCategory: #Testing
		platform: #all.
	
	self assert: (KMRepository default categoryForName: #Testing ) allEntries size = 1.! !

!KeymapBuilderTest methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 12/13/2011 17:37'!
testAttachKeymapAndExecuteExecutes
	| executed morphToTest |
	executed := false.
	
	KMFactory keymapContainer
		initializeKeymap: #test
		executingOn: $a asShortcut, $a asShortcut, $a asShortcut
		doing: [ :receiver | executed := true ]
		inCategory: #Testing
		platform: #all.

	KMFactory keymapContainer attachCategoryName: #Testing to: KMMockMorph.
	
	morphToTest := KMMockMorph new.
	
	{self eventKey: $a. self eventKey: $a. self eventKey: $a}
		do: [:e | morphToTest dispatchKeystrokeForEvent: e].
		
	self assert: executed.! !

!KeymapBuilderTest methodsFor: 'as yet unclassified' stamp: 'DeboraFortini 12/13/2011 17:37'!
testAttachKeymapAttaches
	KMFactory keymapContainer
		initializeKeymap: #test
		executingOn: $r ctrl, $r asShortcut, $r asShortcut
		doing: [ :receiver | "nothing" ]
		inCategory: #Testing
		platform: #all..

	KMFactory keymapContainer attachCategoryName: #Testing to: KMMockMorph.
	
	self assert: ((KMFactory keymapContainer categoriesForClass: KMMockMorph ) anySatisfy: [ :c | c name = #Testing ]).! !
